#include <amxmodx>
#include <cstrike>
#include <zombieplague>
#include <hamsandwich>
#include <fakemeta>
#include <engine>
#include <fun>

new g_Ddeagle

new cvar_Deagle_multi,  cvar_recoil

new bool:g_Deagle[33]

new const v_model[] = "models/zombie_plague/v_Ddeagle.mdl"
new const p_model[] = "models/zombie_plague/p_Ddeagle.mdl"

public plugin_init()
{
	register_plugin("[ZP] Extra Item: Dual Deagle", "1.0", "Strax")
	
	g_Ddeagle = zp_register_extra_item("Dual Deagle", 25, ZP_TEAM_HUMAN)
	RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage")
	
	register_event("CurWeapon", "check_weapon", "be", "1=1")
	register_event("DeathMsg", "Death", "a")
	
	RegisterHam(Ham_Spawn, "player", "fwHamPlayerSpawnPost", 1)
	cvar_Deagle_multi = register_cvar("zp_Ddeagle_multi", "3")
	
	cvar_recoil = register_cvar("zp_Ddeagle_Recoil", "0.5")

}

public zp_extra_item_selected(id, item)
{
	if (item == g_Ddeagle)
	{
		g_Deagle[id] = true
		
		give_item(id, "weapon_elite")

		cs_set_user_bpammo(id, CSW_ELITE, 45)
		
		client_print(id, print_chat, "[ZP] You have bought Dual Deagle!")
	}
}
	

public plugin_precache()
{
	precache_model(v_model)
	precache_model(p_model)
}

public check_weapon(id)
{
	new curweapon = read_data(2)
	if(get_user_weapon(id) == CSW_ELITE && g_Deagle[id])
	{
		if(curweapon == CSW_ELITE)
		{
			set_pev(id, pev_viewmodel2, v_model)
			set_pev(id, pev_weaponmodel2, p_model)
		}
	}
}

public client_connect(id)
{
	g_Deagle[id] = false
}

public client_disconnect(id)
{
	g_Deagle[id] = false
}

public Death()
{
	g_Deagle[read_data(2)] = false
}

public fwHamPlayerSpawnPost(id)
{
	g_Deagle[id] = false
}

public zp_user_infected_post(id)
{
	if (zp_get_user_zombie(id))
	{
	g_Deagle[id] = false
	}
}

public fw_TakeDamage(victim, inflictor, attacker, Float:damage) 
{ 
	if (victim != attacker) 
{ 
	if(get_user_weapon(attacker) == CSW_ELITE && g_Deagle[attacker]) 
	SetHamParamFloat(4, damage * get_pcvar_float(cvar_Deagle_multi)) 
}

}

public fw_rate(id)
{
	if(is_user_connected(id) && g_Deagle[id])
	{
		static Float:flPunchAngle[3]
		flPunchAngle[0] = get_pcvar_float(cvar_recoil)
		
		entity_set_vector(id, EV_VEC_punchangle, flPunchAngle)
	}
	
	return HAM_IGNORED
}	

/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1066\\ f0\\ fs16 \n\\ par }
*/
